unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Button1: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

///////////////////////////////////////////////////////////////////////
//Funo de validao da CNPJ
//Baseado no artigo Algoritmo CNPJ do Clube da Informtica
//http://www.clubedainformatica.com.br/mostraartigo.php?artigo=63
////////////////////////////////////////////////////////////////////////
function ValidaCNPJ(I:string): Boolean;
var
cnpj: array[1..15] of integer;
apoio: array[0..15] of integer;
f: integer;//para uso no for
total: integer;//para totalizao dos valores
D1: integer;//primeiro dgito calculado
D2: integer;//segundo dgito calculado
begin
//Primeiro teste: o nmero de algarismos
if (Length(I)<>14) then result:=false
else
  begin
  //Antes do teste propriamente dito temos que montar a matriz com os
  //os algarismos do CNPJ e depois uma matriz apoio) que ter os nmeros
  //que ajudaro a verificar so dgitos verificadores
  //
  //Monta matriz cnpj
  for f := 1 to 14 do
      begin
       cnpj[f]:=strtoint(I[f]);
      end;
  end;
  //Monta matriz de apoio
  apoio[0]:=6;//s ser usada no clculo do segundo dgito verificador
  apoio[1]:=5;
  apoio[2]:=4;
  apoio[3]:=3;
  apoio[4]:=2;
  apoio[5]:=9;
  apoio[6]:=8;
  apoio[7]:=7;
  apoio[8]:=6;
  apoio[9]:=5;
  apoio[10]:=4;
  apoio[11]:=3;
  apoio[12]:=2;
  //Comea clculo do primeiro dgito verificador
  total:=0;//varivel que conter a soma da operao com os nmeros
  for f := 1 to 12 do
        begin
          total:=total+(cnpj[f]*apoio[f]);
        end;
  D1 := total mod 11;
      if (D1<2) then D1:=0 else D1:=11-D1;
      if (D1<>cnpj[13]) then
        begin
          //Primeiro dgito verificador no confere
          Result:=false;
        end else
                begin
                 //Entrou aqui, ento o primeiro dgito confere!
                 total:=0;
                 for f := 0 to 12 do
                        begin
                           total:=total+(cnpj[f+1]*apoio[f]);
                        end;
                 D2 :=total mod 11;
                 if (D2<2) then D2:=0 else D2:=11-D2;
                 if (D2<>cnpj[14]) then
                        begin
                           //Segunod digito verificador no confere
                           Result:=false;
                        end else Result:=true;
                 end;
  
end;

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
if (ValidaCNPJ(Edit1.Text)) then Label1.Caption:='Validado' else Label1.Caption:='No Validado';
end;

end.
